Imports System.Threading
Imports System.Runtime.InteropServices
Imports VidGrab


Public Class Form1

    Dim vgThread As VideoGrabberThreadObject

    Private Delegate Sub EnableVgButtonsInvoker(ByVal Started As Boolean)
    Public Sub EnableVgButtons(ByVal Started As Boolean)

        If InvokeRequired Then
            Invoke(New EnableVgButtonsInvoker(AddressOf EnableVgButtons), Started)
        Else
            btnStartPreview.Enabled = Not Started
            btnCaptureToControl.Enabled = Started
            btnCaptureToPng.Enabled = Started
            btnStopPreview.Enabled = Started
        End If
    End Sub

    Dim WithEvents vgObject As VideoGrabberThreadObject = Nothing

    Private Sub btnStartPreview_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStartPreview.Click
        If vgObject Is Nothing Then
            vgObject = New VideoGrabberThreadObject(Me, panelDisplay, edtIPCameraURL.Text)
        End If
    End Sub

    Private Sub btnStopPreview_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStopPreview.Click
        If Not (vgObject Is Nothing) Then
            vgObject.Dispose()
            vgObject = Nothing
            EnableVgButtons(False)
        End If

    End Sub

    Private Sub btnCaptureToControl_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCaptureToControl.Click
        Dim FrameBitmap As IntPtr = vgObject.VideoGrabber.GetLastFrameAsHBITMAP(0, False, 0, 0, 0, 0, imgCapturedFrame.Width, imgCapturedFrame.Height, 32)
        If Not FrameBitmap.Equals(IntPtr.Zero) Then
            imgCapturedFrame.Image = Image.FromHbitmap(FrameBitmap)
            WinUtil.DeleteObject(FrameBitmap)
        End If
    End Sub

    Private Sub btnCaptureToPng_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCaptureToPng.Click
        Dim FrameBitmap As IntPtr = vgObject.VideoGrabber.GetLastFrameAsHBITMAP(0, False, 0, 0, 0, 0, 0, 0, 32)
        If Not FrameBitmap.Equals(IntPtr.Zero) Then
            Dim img As Image = Image.FromHbitmap(FrameBitmap)
            img.Save("CapturedFrame.png", System.Drawing.Imaging.ImageFormat.Png)
            WinUtil.DeleteObject(FrameBitmap)
        End If
    End Sub
End Class

Public Class VideoGrabberThreadObject
    Inherits VideoGrabberThread

    Private WithEvents VideoGrabberEvents As VideoGrabber = VideoGrabber

    Private m_IPCameraURL As String = ""
    Private m_Form1 As Form1 = Nothing

    Public Sub New(ByVal OwnerForm As Form1, ByVal ParentControl As Control, ByVal IPCameraURL As String)
        MyBase.New(ParentControl)

        m_Form1 = OwnerForm
        m_IPCameraURL = IPCameraURL
        Thread.Priority = ThreadPriority.Normal
        Thread.Start()
    End Sub

    Protected Overrides Sub VideoGrabberThreadFunc()
        VideoGrabber.VideoSource = TVideoSource.vs_IPCamera
        VideoGrabber.IPCameraURL = m_IPCameraURL
        If VideoGrabber.StartPreview Then
            '... preview started
        End If
    End Sub

    Private Sub vg_OnPreviewStarted(ByVal sender As Object, ByVal e As System.EventArgs) Handles VideoGrabberEvents.OnPreviewStarted
        m_Form1.EnableVgButtons(True)
    End Sub

End Class
